# Class Player
# 
#

source vector.tcl

set iPlayers 4

proc PrintPlayers {} {
    global iPlayers
    global pPlayers

    for {set i 0} {$i < $iPlayers} {incr i} { 
	global $pPlayers($i)

        puts "Player $i:"
        puts "  Position:   ( [subst $$pPlayers($i)(vPos)] )"
        puts "  Direction:  ( [subst $$pPlayers($i)(vDir)] )"
        puts "  Key Left:   ( [subst $$pPlayers($i)(keyLeft)] )"
        puts "  Key Right:  ( [subst $$pPlayers($i)(keyRight)] )"
        puts "  Key Down:   ( [subst $$pPlayers($i)(keyDown)] )"
        puts "  Key Up:     ( [subst $$pPlayers($i)(keyUp)] )"
        puts "  Key Bomb:   ( [subst $$pPlayers($i)(keyBomb)] )"
        puts "  Key Remote: ( [subst $$pPlayers($i)(keyRemote)] )"
    }  
}

proc UpdateKey { keyState } {
   set value [lindex $keyState 0]
   set pressed [lindex $keyState 1]
   set released [lindex $keyState 2]

   return [list [expr $pressed || ( !$pressed && !$released && $value )] 0 [expr $pressed && $released && !$value]]
}

proc UpdatePlayers {} {
    global iPlayers
    global pPlayers

#    puts "Update:"
    for {set i 0} {$i < $iPlayers} {incr i} { 
	global $pPlayers($i)

	set $pPlayers($i)(keyLeft) [UpdateKey [subst $$pPlayers($i)(keyLeft)]]
	set $pPlayers($i)(keyRight) [UpdateKey [subst $$pPlayers($i)(keyRight)]]
	set $pPlayers($i)(keyDown) [UpdateKey [subst $$pPlayers($i)(keyDown)]]
	set $pPlayers($i)(keyUp) [UpdateKey [subst $$pPlayers($i)(keyUp)]]
	set $pPlayers($i)(keyBomb) [UpdateKey [subst $$pPlayers($i)(keyBomb)]]
	set $pPlayers($i)(keyRemote) [UpdateKey [subst $$pPlayers($i)(keyRemote)]]

	set $pPlayers($i)(vDir) [list [expr [lindex [subst $$pPlayers($i)(keyRight)] 0] - [lindex [subst $$pPlayers($i)(keyLeft)] 0]] [expr [lindex [subst $$pPlayers($i)(keyUp)] 0] - [lindex [subst $$pPlayers($i)(keyDown)] 0]] 0 ]

	set $pPlayers($i)(vPos) [vexpr [subst $$pPlayers($i)(vPos)] + [subst $$pPlayers($i)(vDir)]]
#	set $pPlayers($i)(vDir) { 0 0 0 }

#        puts "  Player $i: ( [subst $$pPlayers($i)(vPos)] )"
    }  
}

proc HandleKey { pPlayer key state } {
    global $pPlayer
    global [subst $pPlayer]($key)

#    puts "HandleKey $pPlayer $key $state"

    #puts "lreplace [list [subst $[subst $pPlayer]($key)]] $state $state 1"
    #lreplace [list [subst $[subst $pPlayer]($key)]] $state $state 1

    if { $state == 1 } {
	set [subst $pPlayer]($key) [list [lindex [subst $[subst $pPlayer]($key)] 0] 1 0] 
    } else {
	set [subst $pPlayer]($key) [list [lindex [subst $[subst $pPlayer]($key)] 0] [lindex [subst $[subst $pPlayer]($key)] 1] 1] 
    }

#    set [subst $pPlayer]($key) {1 1 1}

#    PrintPlayers
}

proc HandleMovementKey { pPlayer dirX dirY } {
    global $pPlayer

    set [subst $pPlayer](vDir) [list $dirX $dirY 0]

    UpdatePlayers
}

proc HandleBombKey { pPlayer } {
  puts "$pPlayer: BOMB!!!"
}

proc HandleRemoteKey { pPlayer } {
  puts "$pPlayer: REMOTE!!!"
}

# { Left Right Down Up Bomb Remote }
source keyboard.tcl

set pPlayersSurface { sYellow sMagenta sGreen sCyan }

proc InitPlayers {} {
    global iPlayers
    global pPlayers
    global ppKeyControls


    ##################################################
    # Turn off AutoRepeat for the keyboard
    # X Windows 
    #   xset -r                 # Shell command to turn it off
    #   xset r                  # Shell command to turn it on
    #   XAutoRepeatOff(display) # C command to turn it off
    #   XAutoRepeatOn(display)  # C command to turn it on

    #exec xset -r

    for {set i 0} {$i < $iPlayers} {incr i} { 
	set pPlayers($i) "pPlayer$i"

	global $pPlayers($i)
	
	set $pPlayers($i)(vPos) { 0 0 0 }
	set $pPlayers($i)(vDir) { 0 0 0 }
        # Key board stuff  { Value Pressed Released }
	set $pPlayers($i)(keyLeft) { 0 0 0 }
	set $pPlayers($i)(keyRight) { 0 0 0 }
	set $pPlayers($i)(keyDown) { 0 0 0 }
	set $pPlayers($i)(keyUp) { 0 0 0 }
	set $pPlayers($i)(keyBomb) { 0 0 0 }
	set $pPlayers($i)(keyRemote) { 0 0 0 }

	puts "lreplace $$pPlayers($i)(keyLeft) 1 1 1"

	bind . <KeyPress-[lindex [lindex $ppKeyControls $i] 0]> "HandleKey $pPlayers($i) keyLeft 1"
	bind . <KeyRelease-[lindex [lindex $ppKeyControls $i] 0]> "HandleKey $pPlayers($i) keyLeft 2"
	bind . <KeyPress-[lindex [lindex $ppKeyControls $i] 1]> "HandleKey $pPlayers($i) keyRight 1"
	bind . <KeyRelease-[lindex [lindex $ppKeyControls $i] 1]> "HandleKey $pPlayers($i) keyRight 2"
	bind . <KeyPress-[lindex [lindex $ppKeyControls $i] 2]> "HandleKey $pPlayers($i) keyDown 1"
	bind . <KeyRelease-[lindex [lindex $ppKeyControls $i] 2]> "HandleKey $pPlayers($i) keyDown 2"
	bind . <KeyPress-[lindex [lindex $ppKeyControls $i] 3]> "HandleKey $pPlayers($i) keyUp 1"
	bind . <KeyRelease-[lindex [lindex $ppKeyControls $i] 3]> "HandleKey $pPlayers($i) keyUp 2"
	bind . <KeyPress-[lindex [lindex $ppKeyControls $i] 4]> "HandleKey $pPlayers($i) keyBomb 1"
	bind . <KeyRelease-[lindex [lindex $ppKeyControls $i] 4]> "HandleKey $pPlayers($i) keyBomb 2"
	bind . <KeyPress-[lindex [lindex $ppKeyControls $i] 5]> "HandleKey $pPlayers($i) keyRemote 1"
	bind . <KeyRelease-[lindex [lindex $ppKeyControls $i] 5]> "HandleKey $pPlayers($i) keyRemote 2"

    }
}

InitPlayers

proc UpdatePlayersTclOnly {} {
    UpdatePlayers
    after 33 UpdatePlayersTclOnly
}

#UpdatePlayersTclOnly

#bind . <KeyPress> "puts \"%K\""


######################################################################
# Failed attempt with Richard's Tcl Stuff

# Players
#      } elseif { $gridType == "1" ||  $gridType == "2" ||  $gridType == "3" ||  $gridType == "4" } {
#	set iPlayer [expr $gridType - 1]
#        set [subst $pPlayers($iPlayer)](X) $i
#        set [subst $pPlayers($iPlayer)](Y) $j
#
#	set transX "\{ expr [subst $gridOffsetX] + 2*$[subst $pPlayers($iPlayer)](X) \}"
#        puts "transX = \{ $transX \}"
#
#        slide instance gGrid oOctahedron -surface [lindex $pPlayersSurface $iPlayer] \
#	  -xforms [list [list translate {expr 0} 0 0] ] \
#		        [list scale $gridScale $gridScale $gridScale] \
#		  ]
#
##                            [list expr [subst $gridOffsetY] + 2*$[subst $pPlayers($iPlayer)](Y)] \

