source vector.tcl

set SLF_PI 3.1415927

proc GenerateTorusCircle { pcName fMinorRadius fTheta iThetaSlice iPhiSlices } {
    global SLF_PI

    set fR [expr $fRadius * sin($fPhi) / 2.0]

    set ptCenter(X) 0 
    set ptCenter(Y) [expr $fRadius * cos($fPhi)]
    set ptCenter(Z) 0 

    set fDeltaTheta [expr (2.0*$SLF_PI - $SLF_PI) / $iXHalfSlices]
    set fTheta $SLF_PI

    for { set i 0 } { $i <= $iPhiSlices } { incr i } {
	set pt(X) [expr $fR * cos($fTheta) - $fR]
	set pt(Z) [expr $fR * sin($fTheta)]

	addpoint "p[subst $pcName]_[subst $iXID]_[subst $iYSlice]" [list $pt(X) $pt(Y) $pt(Z)]

	incr iXID
	set fTheta [expr $fTheta + $fDeltaTheta]
    }

    set fDeltaTheta [expr (0.0 - $SLF_PI) / $iXHalfSlices]
    set fTheta [expr $SLF_PI + $fDeltaTheta]

    for { set i 0 } { $i < $iXHalfSlices } { incr i } {
	set pt(X) [expr $fR * cos($fTheta) + $fR]
	set pt(Z) [expr $fR * sin($fTheta)]

	addpoint "p[subst $pcName]_[subst $iXID]_[subst $iYSlice]" [list $pt(X) $pt(Y) $pt(Z)]

	incr iXID
	set fTheta [expr $fTheta + $fDeltaTheta]
    }
}

proc GenerateYinYangSwept { {pcName "YinYangSwept"} {fRadius 1.0} {iXSlices 8} {iYSlices 4} } {
    global SLF_PI

    set fPhi 0
    set fDeltaPhi [expr $SLF_PI / $iYSlices]

    addgroup "g[subst $pcName]"

    for { set i 0 } { $i <= $iYSlices } { incr i } {
	GenerateYinYangSemiCircles $pcName $fRadius $fPhi $iXSlices $i
	set fPhi [expr $fPhi + $fDeltaPhi]
    }

    set iFaceID 0
    set listFaces ""

    for { set j 1 } { $j <= $iYSlices } { incr j } {
	for { set i 1 } { $i <= $iXSlices } { incr i } {
	    if { $j != 1 } {
		addface "f[subst $pcName][subst $iFaceID]" [list "p[subst $pcName]_[expr $i - 1]_[expr $j - 1]" "p[subst $pcName]_[expr $i - 1]_[expr $j]" "p[subst $pcName]_[expr $i]_[expr $j - 1]"]
		set listFaces "$listFaces f[subst $pcName][subst $iFaceID]"
		incr iFaceID
	    }

	    if { $j != $iYSlices } {
		addface "f[subst $pcName][subst $iFaceID]" [list "p[subst $pcName]_[expr $i]_[expr $j - 1]" "p[subst $pcName]_[expr $i - 1]_[expr $j]" "p[subst $pcName]_[expr $i]_[expr $j]"]
		set listFaces "$listFaces f[subst $pcName][subst $iFaceID]"
		incr iFaceID
	    }
	}
    }

    addobject "o[subst $pcName]HeightField" $listFaces 
    addinstance "g[subst $pcName]" "o[subst $pcName]HeightField"
    addinstance "g[subst $pcName]" "s[subst $pcName]HemiSphere"
}
